/*
  LOG_DFE_PARAMCMPPROD responsvel por gravar as informaes
  na tabela LOGOPERA a partir dos registros que forem includos,
  excludos e alterados na tabela PARAMCMPPROD
  Criao: 20/03/2012
  Lucas Primo
*/

CREATE OR REPLACE TRIGGER LOG_DFE_PARAMCMPPROD
AFTER DELETE OR INSERT OR UPDATE
ON PARAMCMPPROD FOR EACH ROW

DECLARE
  V_CDFILLOGOPER VARCHAR2(4);
  V_USUARIO	 VARCHAR2(40);
  V_TIPO	 VARCHAR2(1);
  V_ITPESQ	 VARCHAR2(40);
  V_DESC	 VARCHAR2(300);
  V_DTOPER	 DATE;
  V_CDARVPROD    VARCHAR2(20);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO         := '0';
   V_DESC         := '';
   V_CDFILLOGOPER := '';
   V_CDARVPROD    := '';

   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN

      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || ' Filial= ' || :OLD.CDFILIAL;
      END IF;

      IF :OLD.CDPRODUTO IS NOT NULL THEN
         SELECT CDARVPROD
           INTO V_CDARVPROD
           FROM PRODUTO
          WHERE CDPRODUTO = :OLD.CDPRODUTO;
         V_DESC := V_DESC || ' Prod= ' || V_CDARVPROD;
      END IF;

      IF :OLD.IDBLOQNFSAF IS NOT NULL THEN
         V_DESC := V_DESC || ' Bloq= ' || :OLD.IDBLOQNFSAF;
      END IF;
      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDFILIAL || V_CDARVPROD;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN

         V_DESC := V_DESC || ' Filial= '  || :NEW.CDFILIAL;

         IF NVL(:OLD.CDPRODUTO, '!') <> NVL(:NEW.CDPRODUTO, '!') THEN

            SELECT CDARVPROD
              INTO V_CDARVPROD
              FROM PRODUTO
             WHERE CDPRODUTO = :NEW.CDPRODUTO;

            V_DESC := V_DESC || ' Prod= ' || V_CDARVPROD;
         END IF;

         IF NVL(:OLD.IDBLOQNFSAF, '!') <> NVL(:NEW.IDBLOQNFSAF, '!') THEN
            V_DESC := V_DESC || ' Bloq= ' || :NEW.IDBLOQNFSAF;
         END IF;

         V_CDARVPROD := '';
         SELECT CDARVPROD
           INTO V_CDARVPROD
           FROM PRODUTO
          WHERE CDPRODUTO = :OLD.CDPRODUTO;

         V_TIPO         := '2';
         V_ITPESQ       := :OLD.CDFILIAL || V_CDARVPROD;
         V_CDFILLOGOPER := :OLD.CDFILIAL;
      ELSE
         IF INSERTING THEN

            SELECT CDARVPROD
              INTO V_CDARVPROD
              FROM PRODUTO
             WHERE CDPRODUTO = :NEW.CDPRODUTO;

            V_DESC := V_DESC || ' Filial= ' || :NEW.CDFILIAL;
            V_DESC := V_DESC || ' Prod= '   || V_CDARVPROD;
            V_DESC := V_DESC || ' Bloq= '   || :NEW.IDBLOQNFSAF;

            V_TIPO         := '1';
            V_ITPESQ       := :NEW.CDFILIAL || V_CDARVPROD;
            V_CDFILLOGOPER := :NEW.CDFILIAL;
         END IF;
      END IF;
   END IF;
   IF V_TIPO <> '0' THEN

      IF NOT V_DESC IS NULL THEN
         NMUSUARIO(V_USUARIO);
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,     DTOPERACAO,   NMRESPOPER,  CDPESQITEM, IDTIPOOPER,  DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('PARAMCMPPROD',   V_DTOPER,       V_USUARIO,   V_ITPESQ, V_TIPO, SUBSTR(V_DESC,1,300),
                V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVERRDM, V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);

         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_DFE_PARAMCMPPROD','5.40.000'); END;
/

